﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public abstract class StatelessExpression : Expression {
    private readonly int hashCode;

    protected StatelessExpression() {
      hashCode = GetType().GetHashCode();
    }

    [StorableConstructor]
    protected StatelessExpression(bool deserializing) : base(deserializing) { }

    public override int GetHashCode() {
      return hashCode;
    }

    public override bool Equals(object obj) {
      return ReferenceEquals(this, obj) ||
             hashCode == obj.GetHashCode();
    }
  }
}